unit frmMemoU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TfrmMemo = class(TForm)
    panelBack: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    memo: TMemo;
    panelBtn: TPanel;
    btnOpen: TButton;
    btnClose: TButton;
    btnSetting: TButton;
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Shape1: TShape;
    procedure btnSettingClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure panelBackResize(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  frmMemo: TfrmMemo;

implementation

uses frmPandaTrayU, gui_benri;

{$R *.dfm}

procedure TfrmMemo.btnSettingClick(Sender: TObject);
begin
  frmPandaTray.popsMain.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
  Close;
end;

procedure TfrmMemo.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMemo.panelBackResize(Sender: TObject);
begin
  panelBtn.Left := (panelBack.ClientWidth - panelBtn.Width) div 2;
end;

procedure TfrmMemo.btnOpenClick(Sender: TObject);
begin
  frmPandaTray.TrayShow;
  Close;
end;

procedure TfrmMemo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  frmMemo.memo.Lines.SaveToFile(AppPath + FILE_MEMO);
end;

procedure TfrmMemo.FormShow(Sender: TObject);
begin
  if FileExists(AppPath + FILE_MEMO) then
  begin
    frmMemo.memo.Lines.LoadFromFile(AppPath + FILE_MEMO);
  end;
end;

end.
